"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var BaseMessage_1 = require("./BaseMessage");
var ImgMessage = /** @class */ (function (_super) {
    __extends(ImgMessage, _super);
    function ImgMessage(msg) {
        var _this = _super.call(this) || this;
        _this.ImgMessageConfig = {
            url: '',
            width: 0,
            height: 0
        };
        _this.mImg = new Image();
        _this.ImgMessageConfig = Object.assign({}, _this.ImgMessageConfig, msg);
        return _this;
    }
    ImgMessage.prototype.onCreate = function (callback) {
        var _this = this;
        this.mImg.onload = function () {
            _this.ImgMessageConfig.width = _this.ImgMessageConfig.width || _this.mImg.width || 300;
            _this.ImgMessageConfig.height = _this.ImgMessageConfig.height || _this.mImg.height || 200;
            callback(true);
        };
        this.mImg.onerror = function () {
            document.body.removeChild(_this.mImg);
            callback(false);
        };
        this.mImg.src = this.ImgMessageConfig.url;
        this.mImg.style.position = 'fixed';
        this.mImg.style.top = '-1000px';
        this.mImg.style.left = '-1000px';
        document.body.appendChild(this.mImg);
    };
    ImgMessage.prototype.onMeasure = function (ctx, trackInfo) {
        return {
            width: this.ImgMessageConfig.width,
            height: this.ImgMessageConfig.height
        };
    };
    ImgMessage.prototype.onLayout = function (ctx, trackInfo) {
        if (!this.isLayout) {
            this.isLayout = true;
            return {
                top: trackInfo.top,
                left: ctx.canvas.width
            };
        }
        this.position.left -= 3;
        return this.position;
    };
    ImgMessage.prototype.onDraw = function (ctx, trackInfo) {
        ctx.drawImage(this.mImg, this.position.left, this.position.top, this.size.width, this.size.height);
    };
    ImgMessage.prototype.onDestroyed = function () {
        var result = this.position.left < -this.size.width;
        if (result) {
            document.body.removeChild(this.mImg);
        }
        return result;
    };
    return ImgMessage;
}(BaseMessage_1.BaseMessage));
exports.default = ImgMessage;
//# sourceMappingURL=ImgMessage.js.map