"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var BaseMessage_1 = require("./BaseMessage");
var VideoMessage = /** @class */ (function (_super) {
    __extends(VideoMessage, _super);
    function VideoMessage(msg) {
        var _this = _super.call(this) || this;
        _this.VideoMessageConfig = {
            url: '',
            width: 300,
            height: 200
        };
        _this.mIsPlay = false;
        _this.mVideo = document.createElement('video');
        _this.VideoMessageConfig = Object.assign({}, _this.VideoMessageConfig, msg);
        return _this;
    }
    VideoMessage.prototype.onCreate = function (callback) {
        var _this = this;
        this.mVideo.addEventListener('canplay', function () {
            callback(true);
        });
        this.mVideo.addEventListener('error', function () {
            document.body.removeChild(_this.mVideo);
            callback(false);
        });
        this.mVideo.src = this.VideoMessageConfig.url;
        this.mVideo.style.position = 'fixed';
        this.mVideo.style.top = '-4000px';
        this.mVideo.style.left = '-4000px';
        this.mVideo.preload = 'auto';
        this.mVideo.loop = true;
        document.body.appendChild(this.mVideo);
    };
    VideoMessage.prototype.onMeasure = function (ctx, trackInfo) {
        if (!this.mIsPlay) {
            this.mIsPlay = true;
            this.mVideo.play();
        }
        return {
            width: this.VideoMessageConfig.width,
            height: this.VideoMessageConfig.height
        };
    };
    VideoMessage.prototype.onLayout = function (ctx, trackInfo) {
        console.log(this.size);
        if (!this.isLayout) {
            this.isLayout = true;
            return {
                top: trackInfo.top,
                left: ctx.canvas.width
            };
        }
        this.position.left -= 3;
        return this.position;
    };
    VideoMessage.prototype.onDraw = function (ctx, trackInfo) {
        ctx.drawImage(this.mVideo, this.position.left, this.position.top, this.size.width, this.size.height);
    };
    VideoMessage.prototype.onDestroyed = function () {
        var result = this.position.left < -this.size.width;
        if (result) {
            document.body.removeChild(this.mVideo);
        }
        return result;
    };
    return VideoMessage;
}(BaseMessage_1.BaseMessage));
exports.default = VideoMessage;
//# sourceMappingURL=VideoMessage.js.map